/* All Rights reserved */

#include <AppKit/AppKit.h>
#include "MyView.h"

@implementation MyView

- (void)setBehaviorCode: (int)aCode
{
  behaviorCode = aCode;
}

- (void)drawRect: (NSRect)aRect
{
  switch (behaviorCode) {
  case 0: {
    // just clear view, used for outside drawing
    //[[NSColor whiteColor] set];
    //NSRectFill(aRect);
    break;
  }
  case 1: {
    // file image
    NSImage *image = [[NSImage alloc] initWithContentsOfFile: @"heatbugs.tiff"];
    [image drawInRect: aRect fromRect: NSZeroRect operation: NSCompositeSourceAtop fraction: 1.0];
    break;
  }
  case 2: {
    // image no scale
    NSRect imRect = NSMakeRect(0, 0, 80, 80);
    NSImage *image = [[NSImage alloc] initWithSize:imRect.size];
    NSBitmapImageRep *imageRep = [[NSBitmapImageRep alloc]
				   initWithBitmapDataPlanes:NULL
				   pixelsWide:imRect.size.width
				   pixelsHigh:imRect.size.height
				   bitsPerSample:8
				   samplesPerPixel:3
				   hasAlpha:NO
				   isPlanar:NO
				   colorSpaceName:NSDeviceRGBColorSpace
				   bytesPerRow:0
				   bitsPerPixel:0];
    [image addRepresentation:imageRep];

    // draw some random dots
    [image lockFocus];

    [[NSColor blackColor] set];
    NSRectFill(imRect);

    int i;
    for (i = 0; i < 100; ++i) {
      int x = 80 * ((double)rand() / (double)RAND_MAX);
      int y = 80 * ((double)rand() / (double)RAND_MAX);
      NSRect dotRect = NSMakeRect(x,y,1,1);
      [[NSColor redColor] set];
      NSRectFill(dotRect);
    }

    [image unlockFocus];

    [image drawInRect: imRect fromRect: NSZeroRect operation: NSCompositeSourceAtop fraction: 1.0];
    break;
  }
  case 3: {
    // image scale
    NSRect imRect = NSMakeRect(0, 0, 80, 80);
    NSImage *image = [[NSImage alloc] initWithSize:imRect.size];
    NSBitmapImageRep *imageRep = [[NSBitmapImageRep alloc]
				   initWithBitmapDataPlanes:NULL
				   pixelsWide:imRect.size.width
				   pixelsHigh:imRect.size.height
				   bitsPerSample:8
				   samplesPerPixel:3
				   hasAlpha:NO
				   isPlanar:NO
				   colorSpaceName:NSDeviceRGBColorSpace
				   bytesPerRow:0
				   bitsPerPixel:0];
    [image addRepresentation:imageRep];

    // draw some random dots
    [image lockFocus];

    [[NSColor blackColor] set];
    NSRectFill(imRect);

    int i;
    for (i = 0; i < 100; ++i) {
      int x = 80 * ((double)rand() / (double)RAND_MAX);
      int y = 80 * ((double)rand() / (double)RAND_MAX);
      NSRect dotRect = NSMakeRect(x,y,1,1);
      [[NSColor redColor] set];
      NSRectFill(dotRect);
    }

    [image unlockFocus];

    [image drawInRect: aRect fromRect: NSZeroRect operation: NSCompositeSourceAtop fraction: 1.0];
    break;
  }
  }
}

@end
